function [chlflagged] = chlflag(chl,flags)
% Luke Carberry, 03/16/2022
% function to flag chlorophyll imagery based on the accompanying flag matrix
% more information at: https://oceancolor.gsfc.nasa.gov/atbd/ocl2flags/
% comment or uncomment flags to change flagging
% optimal flags for SBC are 1,3,4,8,9,14,15,20,22

lf = bitand(flags,[2^1]); %2^1 is the land flag
chl(lf==2^1) = NaN;
% lf = bitand(flags,[2^2]); % prodwarn 
% chl(lf==2^2) = NaN;
lf = bitand(flags,[2^3]); % hi glint
chl(lf==2^3) = NaN;
lf = bitand(flags,[2^4]); %high light
chl(lf==2^4) = NaN;
% lf = bitand(flags,[2^5]); % hisatzen
% chl(lf==2^5) = NaN;
% lf = bitand(flags,[2^6]); % coastz
% chl(lf==2^6) = NaN;
% lf = bitand(flags,[2^7]); % spare
% chl(lf==2^7) = NaN;
lf = bitand(flags,[2^8]); %stray light
chl(lf==2^8) = NaN;
lf = bitand(flags,[2^9]); %cloud ice
chl(lf==2^9) = NaN;
% lf = bitand(flags,[2^10]); % coccolith
% chl(lf==2^10) = NaN;
% lf = bitand(flags,[2^11]); % turbidw
% chl(lf==2^11) = NaN;
% lf = bitand(flags,[2^12]); % hisolzen
% chl(lf==2^12) = NaN;
% lf = bitand(flags,[2^13]); % spare
% chl(lf==2^13) = NaN;
lf = bitand(flags,[2^14]); %low lw
chl(lf==2^14) = NaN;
lf = bitand(flags,[2^15]); %chl fail
chl(lf==2^15) = NaN;
% lf = bitand(flags,[2^16]); % navwarn
% chl(lf==2^16) = NaN;
% lf = bitand(flags,[2^17]); % absaer
% chl(lf==2^17) = NaN;
% lf = bitand(flags,[2^18]); % spare
% chl(lf==2^18) = NaN;
% lf = bitand(flags,[2^19]); % maxaeriter
% chl(lf==2^19) = NaN;
lf = bitand(flags,[2^20]); %modglint
chl(lf==2^20) = NaN;
% lf = bitand(flags,[2^21]); % chlwarn
% chl(lf==2^21) = NaN;
lf = bitand(flags,[2^22]); %Atmospheric correction is suspect
chl(lf==2^22) = NaN;
% lf = bitand(flags,[2^23]); % spare
% chl(lf==2^23) = NaN;
% lf = bitand(flags,[2^24]); % seaice
% chl(lf==2^24) = NaN;
% lf = bitand(flags,[2^25]); % navfail
% chl(lf==2^25) = NaN;
% lf = bitand(flags,[2^26]); % filter
% chl(lf==2^26) = NaN;
% lf = bitand(flags,[2^27]); % spare
% chl(lf==2^27) = NaN;
% lf = bitand(flags,[2^28]); % bowtiedel
% chl(lf==2^28) = NaN;
% lf = bitand(flags,[2^29]); % hipol
% chl(lf==2^29) = NaN;
% lf = bitand(flags,[2^30]); % prodfail
% chl(lf==2^30) = NaN;
% lf = bitand(flags,[2^31]); % spare
% chl(lf==2^31) = NaN;

chlflagged = chl;

